/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.ingreso;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zkplus.databind.BindingListModel;
import org.zkoss.zkplus.databind.BindingListModelList;
import org.zkoss.zul.Button;
import org.zkoss.zul.Checkbox;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Messagebox;
import org.zkoss.zul.Radiogroup;
import org.zkoss.zul.Row;
import org.zkoss.zul.Textbox;

import com.rjconsultores.ventaboletos.entidad.Articulo;
import com.rjconsultores.ventaboletos.entidad.FormaPago;
import com.rjconsultores.ventaboletos.entidad.ParamArticulo;
import com.rjconsultores.ventaboletos.entidad.TipoEventoExtra;
import com.rjconsultores.ventaboletos.exception.BusinessException;
import com.rjconsultores.ventaboletos.service.ArticuloService;
import com.rjconsultores.ventaboletos.service.FormaPagoService;
import com.rjconsultores.ventaboletos.service.ParamArticuloService;
import com.rjconsultores.ventaboletos.service.TipoEventoExtraService;
import com.rjconsultores.ventaboletos.utilerias.ApplicationProperties;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.MyTextbox;

/**
 * 
 * @author Rafius
 */
@Controller("editarTipoEventoExtraController")
@Scope("prototype")
public class EditarTipoEventoExtraController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;
	@Autowired
	private TipoEventoExtraService tipoEventoExtraService;
	@Autowired
	private ArticuloService articuloService;
	@Autowired
	private FormaPagoService formaPagoService;
	@Autowired
	private ParamArticuloService paramArticuloService;
	private List<Articulo> lsArticulo;
	private List<FormaPago> lsFormaPago;
	private List<ParamArticulo> lsParamArticulo;
	private TipoEventoExtra tipoEventoExtra;
	private MyListbox tipoEventoExtraList;
	private MyTextbox txtNome;
	private Button btnApagar;
	private Textbox impMax;
	private Textbox porcIva;
	private Checkbox cbValidaCorte;
	private Checkbox cbValidaDocumento;
	private Checkbox cbContrapartida;
	private Checkbox cbOrdenServicio;
	private Checkbox cbBoleto;
	private Combobox cmbIndOperacion;
	private Combobox cmbFormaPago2;
	private Combobox cmbParamArticulo;
	private Combobox cmbParamArticulo2;
	private Combobox cmbFormaPago;
	private Radiogroup sv1;
	private Radiogroup sv2;
	private Row rowParamArticulo;
	private Row rowParamArticulo2;
	private static Logger log = Logger.getLogger(EditarTipoEventoExtraController.class);

	public List<ParamArticulo> getLsParamArticulo() {
		return lsParamArticulo;
	}

	public void setLsParamArticulo(List<ParamArticulo> lsParamArticulo) {
		this.lsParamArticulo = lsParamArticulo;
	}

	public TipoEventoExtra getTipoEventoExtra() {
		return tipoEventoExtra;
	}

	public void setTipoEventoExtra(TipoEventoExtra tipoEventoExtra) {
		this.tipoEventoExtra = tipoEventoExtra;
	}

	public List<Articulo> getLsArticulo() {
		return lsArticulo;
	}

	public void setLsArticulo(List<Articulo> lsArticulo) {
		this.lsArticulo = lsArticulo;
	}

	public List<FormaPago> getLsFormaPago() {
		return lsFormaPago;
	}

	public void setLsFormaPago(List<FormaPago> lsFormaPago) {
		this.lsFormaPago = lsFormaPago;
	}

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		lsArticulo = articuloService.obtenerTodos();
		lsFormaPago = formaPagoService.obtenerTodos();
		lsParamArticulo = paramArticuloService.obtenerTodos();

		super.doAfterCompose(comp);

		tipoEventoExtra = (TipoEventoExtra) Executions.getCurrent().getArg().get("tipoEventoExtra");
		tipoEventoExtraList = (MyListbox) Executions.getCurrent().getArg().get("tipoEventoExtraList");

		if (tipoEventoExtra.getTipoeventoextraId() != null) {
			cbContrapartida.setChecked(tipoEventoExtra.getIndcontrapartida());
			cbOrdenServicio.setChecked(tipoEventoExtra.getIndordenservicio());
			cbValidaCorte.setChecked(tipoEventoExtra.getIndvalidacorte());
			cbValidaDocumento.setChecked(tipoEventoExtra.getIndvalidadocumento());
			if (tipoEventoExtra.getIndboleto() == Boolean.TRUE) {
				cbBoleto.setChecked(true);
			}

			onChange$cmbIndOperacion(null);

			if (tipoEventoExtra.getIndtipo() != null) {
				if (tipoEventoExtra.getIndtipo().equals("0")) {
					sv1.setSelectedIndex(1);
				} else {
					sv1.setSelectedIndex(0);
				}
			}

			if (tipoEventoExtra.getIndtipo2() != null) {
				if (tipoEventoExtra.getIndtipo2().equals("0")) {
					sv2.setSelectedIndex(1);
				} else {
					sv2.setSelectedIndex(0);
				}
			}
		} else {
			btnApagar.setVisible(false);
		}

		// Sino es para exhibir la cuenta contable, no dejo las lines visibles.
		if (!exhibirCuentaContable()) {
			rowParamArticulo.setVisible(false);
			rowParamArticulo2.setVisible(false);

			cmbParamArticulo.setConstraint("");
		}

		txtNome.focus();
	}

	public void onChange$cmbIndOperacion(Event ev) throws InterruptedException {
		if (tipoEventoExtra.getIndoperacion() != null) {
			sv1.setSelectedIndex(-1);
			sv2.setSelectedIndex(-1);
			if (tipoEventoExtra.getIndoperacion().equals(Short.parseShort("1"))) {
				cbValidaCorte.setDisabled(true);
				cbValidaCorte.setChecked(false);

				cbValidaDocumento.setDisabled(false);

				cbContrapartida.setDisabled(true);
				cbContrapartida.setChecked(false);

				cbBoleto.setDisabled(false);

				cbOrdenServicio.setDisabled(true);
				cbOrdenServicio.setChecked(false);

				BindingListModel listModelCiudad = new BindingListModelList(new ArrayList<FormaPago>(), true);
				cmbFormaPago2.setModel(listModelCiudad);

				cmbFormaPago2.setDisabled(true);

				cmbFormaPago2.setSelectedItem(null);

				BindingListModel listModelParmArticulo = new BindingListModelList(new ArrayList<ParamArticulo>(), true);
				cmbParamArticulo2.setModel(listModelParmArticulo);

				cmbParamArticulo2.setDisabled(true);

				cmbParamArticulo2.setSelectedItem(null);

			} else if (tipoEventoExtra.getIndoperacion().equals(Short.parseShort("2"))) {

				cbValidaCorte.setDisabled(true);
				cbValidaCorte.setChecked(true);

				cbValidaDocumento.setDisabled(false);

				cbContrapartida.setDisabled(true);
				cbContrapartida.setChecked(true);

				cbBoleto.setDisabled(true);
				cbBoleto.setChecked(false);

				cbOrdenServicio.setDisabled(false);

				BindingListModel listModelCiudad = new BindingListModelList(lsFormaPago, true);
				cmbFormaPago2.setModel(listModelCiudad);
				cmbFormaPago2.setDisabled(false);

				BindingListModel listModelParmArticulo = new BindingListModelList(lsParamArticulo, true);
				cmbParamArticulo2.setModel(listModelParmArticulo);

				cmbParamArticulo2.setDisabled(false);

				cmbParamArticulo2.setSelectedItem(null);

			} else if (tipoEventoExtra.getIndoperacion().equals(Short.parseShort("3"))) {

				cbValidaCorte.setDisabled(true);
				cbValidaCorte.setChecked(false);

				cbValidaDocumento.setChecked(true);
				cbValidaDocumento.setDisabled(true);

				cbContrapartida.setDisabled(true);
				cbContrapartida.setChecked(true);

				cbBoleto.setDisabled(true);
				cbBoleto.setChecked(false);

				cbOrdenServicio.setDisabled(true);
				cbOrdenServicio.setChecked(false);

				BindingListModel listModelCiudad = new BindingListModelList(lsFormaPago, true);
				cmbFormaPago2.setModel(listModelCiudad);

				cmbFormaPago2.setDisabled(false);

				BindingListModel listModelParmArticulo = new BindingListModelList(lsParamArticulo, true);
				cmbParamArticulo2.setModel(listModelParmArticulo);

				cmbParamArticulo2.setDisabled(false);

				cmbParamArticulo2.setSelectedItem(null);
			}
		}
	}

	public void onClick$btnSalvar(Event ev) throws InterruptedException {

		txtNome.getValue();
		impMax.getValue();
		cmbIndOperacion.getValue();
		porcIva.getValue();
		cmbFormaPago.getValue();
		cmbParamArticulo.getValue();

		if (sv1.getSelectedIndex() == -1) {
			Messagebox.show(Labels.getLabel("MSG.necesita.tipoEvento"),
					Labels.getLabel("editarTipoEventoExtraController.MSG.tipoObligatolia"),
					Messagebox.OK, Messagebox.EXCLAMATION);
			return;
		}

		try {

			if (!cmbFormaPago2.isDisabled() && cmbFormaPago2.getSelectedItem() == null) {
				Messagebox.show(Labels.getLabel("MSG.necesita.formaPago"),
						Labels.getLabel("editarTipoEventoExtraController.MSG.formaPagoObligatolia"),
						Messagebox.OK, Messagebox.EXCLAMATION);
				return;
			}

			if (exhibirCuentaContable()) {
				if (cmbIndOperacion.getSelectedItem() != null) {
					String indOp = (String) cmbIndOperacion.getSelectedItem().getValue();
					if (!cmbParamArticulo2.isDisabled() && indOp.equals("3")) {
						if (cmbParamArticulo2.getSelectedItem() == null) {
							Messagebox.show(Labels.getLabel("MSG.necesita.contaContable"),
									Labels.getLabel("editarTarjetaViajeController.MSG.cuentaContableObligatorio"),
									Messagebox.OK, Messagebox.EXCLAMATION);
							return;
						}
					}
				}
			}

			tipoEventoExtra.setActivo(Boolean.TRUE);
			tipoEventoExtra.setFecmodif(Calendar.getInstance().getTime());
			tipoEventoExtra.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());

			List<TipoEventoExtra> lsTipoEventoExtra = tipoEventoExtraService.buscar(tipoEventoExtra.getDescTipoEvento());
			boolean podeSalvar = false;
			if (lsTipoEventoExtra.isEmpty()) {
				podeSalvar = true;
			} else {
				for (TipoEventoExtra b : lsTipoEventoExtra) {
					if (b.getTipoeventoextraId().equals(tipoEventoExtra.getTipoeventoextraId())) {
						podeSalvar = true;
					}
				}
			}
			if (!podeSalvar) {
				Messagebox.show(Labels.getLabel("MSG.Registro.Existe"),
						Labels.getLabel("editarTipoEventoExtraController.window.title"),
						Messagebox.OK, Messagebox.EXCLAMATION);

				return;
			} else {

				if (sv1.getSelectedIndex() == 0) {
					tipoEventoExtra.setIndtipo("1");
				} else {
					tipoEventoExtra.setIndtipo("0");
				}

				if (sv2.getSelectedIndex() == -1) {
					tipoEventoExtra.setIndtipo2(null);
				} else if (sv2.getSelectedIndex() == 0) {
					tipoEventoExtra.setIndtipo2("1");
				} else {
					tipoEventoExtra.setIndtipo2("0");
				}

				tipoEventoExtra.setFormaPago((FormaPago) cmbFormaPago.getSelectedItem().getValue());

				tipoEventoExtra.setIndvalidacorte(cbValidaCorte.isChecked());
				tipoEventoExtra.setIndvalidadocumento(cbValidaDocumento.isChecked());
				tipoEventoExtra.setIndcontrapartida(cbContrapartida.isChecked());
				tipoEventoExtra.setIndordenservicio(cbOrdenServicio.isChecked());
				tipoEventoExtra.setIndboleto(cbBoleto.isChecked() ? Boolean.TRUE : Boolean.FALSE);

				tipoEventoExtra.setParamArticulo(cmbParamArticulo.getSelectedItem() == null ? null : (ParamArticulo) cmbParamArticulo.getSelectedItem().getValue());
				tipoEventoExtra.setParamArticulo2(cmbParamArticulo2.getSelectedItem() == null ? null : (ParamArticulo) cmbParamArticulo2.getSelectedItem().getValue());

				if (tipoEventoExtra.getTipoeventoextraId() == null) {
					tipoEventoExtraService.suscribir(tipoEventoExtra);
					tipoEventoExtraList.addItem(tipoEventoExtra);
				} else {
					tipoEventoExtraService.actualizacion(tipoEventoExtra);
					tipoEventoExtraList.updateItem(tipoEventoExtra);
				}
			}

			Messagebox.show(Labels.getLabel("editarTipoEventoExtraController.MSG.suscribirOK"),
					Labels.getLabel("editarTipoEventoExtraController.window.title"),
					Messagebox.OK, Messagebox.INFORMATION);

			closeWindow();

		} catch (Exception ex) {
			log.error("editarTipoEventoExtraController: " + ex);
			Messagebox.show(Labels.getLabel("MSG.Error"),
					Labels.getLabel("editarTipoEventoExtraController.window.title"),
					Messagebox.OK, Messagebox.ERROR);
		}
	}

	public void onCheck$sv1(Event ev) {
		String indOperacion = null;
		if (cmbIndOperacion.getSelectedItem() != null) {
			indOperacion = (String) cmbIndOperacion.getSelectedItem().getValue();
		} else {
			return;
		}
		if (!indOperacion.equals("1")) {
			if (sv1.getSelectedIndex() == 0) {
				sv2.setSelectedIndex(1);
			} else {
				sv2.setSelectedIndex(0);
			}
		}
	}

	public void onClick$btnApagar(Event ev) throws InterruptedException {
		try {
			int resp = Messagebox.show(Labels.getLabel("editarTipoEventoExtraController.MSG.borrarPergunta"),
					Labels.getLabel("editarTipoEventoExtraController.window.title"),
					Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

			if (resp == Messagebox.YES) {
				tipoEventoExtraService.borrar(tipoEventoExtra);

				Messagebox.show(Labels.getLabel("editarTipoEventoExtraController.MSG.borrarOK"),
						Labels.getLabel("editarTipoEventoExtraController.window.title"), Messagebox.OK,
						Messagebox.INFORMATION);

				tipoEventoExtraList.removeItem(tipoEventoExtra);

				closeWindow();
			}

		} catch (BusinessException ex) {
			Messagebox.show(ex.getLocalizedMessage(),
					Labels.getLabel("editarTipoEventoExtraController.window.title"),
					Messagebox.OK, Messagebox.INFORMATION);
		}
	}

	private boolean exhibirCuentaContable() {
		return ApplicationProperties.getInstance().exhibirCuentaContableTiposEventos();
	}
}
